clear

a=0;
b=10;
d=20;
m=30;
opt=[sqrt(eps) 1e-7 500 2];

%Orthogonal collocation:

tic
cf0=[1;0.2];
for n=2:d+1
    [z,x]=chebynodes(a,b,n);
    T=cheby(z,n-1);
    cfc=newtonsolve('resfuncol',cf0,opt,x,T);
    cf0=newguess(cfc,1);
end
toc

% Galerkin

tic
cf0=[1;0.2];
[z,x]=chebynodes(a,b,m);
for n=2:d+1
    T=cheby(z,n-1);
    cfg=newtonsolve('resfungal',cf0,opt,x,T);
    cf0=newguess(cfg,1);
end
toc

% Check the quality of approximation

[z,x]=uniformnodes(a,b,1000);
f=testfun(x);
hc=chebypol(z,cfc);
hg=chebypol(z,cfg);
er=[f-hc,f-hg];
disp(['Avg. Abs. Er.: ' num2str(mean(abs(er)))])
disp(['Avg. Med. Er.: ' num2str(median(abs(er)))])    
disp(['Std. Er.:      ' num2str(std(er))])
disp(['Max. Abs. Er.: ' num2str(max(abs(er)))])
subplot(2,1,1), plot(x,[f,hc,hg])
legend('True','Col','Gal',0), ylabel('f(x)')
subplot(2,1,2), plot(x,er)
legend('Col','Gal',0), ylabel('App. error')