clear

a=0;
b=10;
d=20;
m=30;
opt=[sqrt(eps) 1e-7 500 2];

% Orthogonal collocation:

tic
cf0=[0.6;-0.15;-0.5;0];
for n=2:d+1
    [z,x]=chebynodes(a,b,n);
    xv=stack([x,x]);
    zv=stack([z,z]);
    T=cheby(zv,n-1);
    cfc=newtonsolve('resfuncol2',cf0,opt,xv,T);
    cf0=newguess(cfc,2);
end
toc

% Galerkin

tic
cf0=[0.6;-0.15;-0.5;0];
[z,x]=chebynodes(a,b,m);
for n=2:d+1
    xv=stack([x,x]);
    zv=stack([z,z]);
    T=cheby(zv,n-1);
    cfg=newtonsolve('resfungal2',cf0,opt,xv,T);
    cf0=newguess(cfg,2);
end
toc

% Check the quality of approximation

p=50;
[z,x]=uniformnodes(a,b,p);
xv=stack([x,x]);
zv=stack([z,z]);
f=testfun2(xv);
hc=chebypol(zv,cfc);
hg=chebypol(zv,cfg);
er=[f-hc,f-hg];
disp(['Avg. Abs. Er.: ' num2str(mean(abs(er)))])
disp(['Avg. Med. Er.: ' num2str(median(abs(er)))])    
disp(['Std. Er.:      ' num2str(std(er))])
disp(['Max. Abs. Er.: ' num2str(max(abs(er)))])
f=reshape(f,p,p)';
hc=reshape(hc,p,p)';
hg=reshape(hg,p,p)';
erc=reshape(er(:,1),p,p)';
erg=reshape(er(:,2),p,p)';
subplot(2,2,1), surf(x,x,hc), title('Cheby')
subplot(2,2,2), surf(x,x,hg), title('Gal')
subplot(2,2,3), surf(x,x,erc), title('Err_{Cheby}')
subplot(2,2,4), surf(x,x,erg), title('Err_{Gal}')
